<template>
  <ck-taskbar>
    <template #left>
      <v-btn-group
        class="ma-2"
        divided
      >
        <v-tooltip
          location="bottom"
          text="Shift + N"
        >
          <template v-slot:activator="{ props }">
            <v-btn
              v-bind="props"
              @click="isCreatingChecklist = true"
              color="success"
              prepend-icon="mdi-plus"
            >New checklist</v-btn>
          </template>
        </v-tooltip>
      </v-btn-group>
    </template>
    <template #right>
      <v-btn-group
        class="ma-2"
        divided
      >
        <btn-theme></btn-theme>
      </v-btn-group>
    </template>
  </ck-taskbar>
  <v-container class=px-lg-16 px-md-6>
    <v-row justify="space-evenly">
      <v-col
        cols="12"
        sm="10"
        md="6"
        lg="4"
        v-for="(ck, i) in checklists"
        :key="ck.id"
      >
        <ck-checklist-card :focus-on-mount="i === 0" :tabindex="i+1" :checklist="ck" :ref="'checklist-' + ck.id"></ck-checklist-card>
      </v-col>
    </v-row>
  </v-container>
  <create-checklist-dialog
    v-model="isCreatingChecklist"
    @CREATE="(checklist) => {
      useChecklistStore().createChecklist(checklist)
      isCreatingChecklist = false}"
    @CANCEL="isCreatingChecklist = false"
  ></create-checklist-dialog>
</template>

<script setup>
import CreateChecklistDialog from '@/components/checklist/create-checklist-dialog.vue'
import CkTaskbar from '@/components/commons/ck-taskbar.vue'
import BtnTheme from '@/components/commons/task-icons/btn-theme.vue'
</script>

<script>
import { defineComponent } from 'vue'
import { useChecklistStore } from '@/stores/checklists.js'
import CkChecklistCard from '@/components/checklist/ck-checklist-card.vue'
import { useKeypress } from 'vue3-keypress'

export default defineComponent({
  name: 'HomeView',
  components: { CkChecklistCard },
  data() {
    return {
      isCreatingChecklist: false
    }
  },
  computed: {
    checklists() {
      return useChecklistStore().checklists
    },
  },
  created() {
    useChecklistStore().fetchChecklists()
    useKeypress({
      keyEvent: "keyup",
      keyBinds: [
        {
          keyCode: 78,
          modifiers: ["shiftKey"],
          success: () => this.isCreatingChecklist = true,
          preventDefault: true
        },
      ]
    })
  },
})
</script>
